"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Emitter_1 = require("../listener/Emitter");
var react_native_1 = require("react-native");
var Log_1 = require("../logger/Log");
var Orientation = (function () {
    function Orientation() {
    }
    Orientation.init = function () {
        this.handleResize();
    };
    Orientation.destroy = function () {
    };
    Orientation.getWidth = function () {
        return 0;
    };
    Orientation.getHeight = function () {
        return 0;
    };
    Orientation.checkIsMobile = function () {
        var isMobile = false;
        var innerWidth = this.getWidth();
        if (innerWidth <= 768) {
            isMobile = true;
        }
        return isMobile;
    };
    Orientation.updateSize = function () {
        this.size = react_native_1.Dimensions.get('window');
    };
    Orientation.handleResize = function () {
        this.updateSize();
        if (this.listener) {
            clearTimeout(this.listener);
        }
        this.listener = setTimeout(function () {
            Log_1.default.debug('onOrientationChange');
            Emitter_1.default.emit('onOrientationChange', true);
        }, 10);
    };
    return Orientation;
}());
Orientation.size = { scale: 1, fontScale: 1, width: 100, height: 100 };
exports.default = Orientation;
