export interface UserSettings {
    themes: Themes;
    defaultTheme?: string;
}
export interface Settings {
    themes: Themes;
    defaultTheme: string;
}
export interface AppTheme {
    [key: string]: any;
}
export interface Themes {
    [key: string]: AppTheme;
}
export default class Theme {
    static settings: Settings;
    static theme: string;
    static vars: AppTheme;
    static init(settings: UserSettings): Promise<void>;
    static setTheme(theme: string): void;
    static getTheme(): string;
    static getUserTheme(): Promise<string>;
    static getDefaultTheme(): string;
}
