"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TinyColor = require('tinycolor2');
var react_native_1 = require("react-native");
var ThemeBuilder = (function () {
    function ThemeBuilder() {
    }
    ThemeBuilder.allowShadow = function () {
        return !(react_native_1.Platform.OS === 'android' && react_native_1.Platform.Version < 21);
    };
    ThemeBuilder.build = function (defaults) {
        var allowShadow = this.allowShadow();
        return {
            defaults: defaults,
            darkMode: defaults.darkMode,
            loadingColor: defaults.textColor,
            buttonDefaultIconColor: defaults.textSecondaryColor,
            buttonPrimaryIconColor: defaults.textActiveSecondaryColor,
            buttonDangerIconColor: defaults.textActiveSecondaryColor,
            buttonWarningIconColor: defaults.textActiveSecondaryColor,
            buttonInfoIconColor: defaults.textActiveSecondaryColor,
            buttonSuccessIconColor: defaults.textActiveSecondaryColor,
            buttonDefaultTextColor: defaults.textColor,
            buttonPrimaryTextColor: defaults.textActiveColor,
            buttonDangerTextColor: defaults.textActiveColor,
            buttonWarningTextColor: defaults.textActiveColor,
            buttonInfoTextColor: defaults.textActiveColor,
            buttonSuccessTextColor: defaults.textActiveColor,
            buttonDefaultBackgroundColor: defaults.defaultColor,
            buttonPrimaryBackgroundColor: defaults.primaryColor,
            buttonDangerBackgroundColor: defaults.dangerColor,
            buttonWarningBackgroundColor: defaults.warningColor,
            buttonInfoBackgroundColor: defaults.infoColor,
            buttonSuccessBackgroundColor: defaults.successColor,
            buttonDefaultShadowColor: TinyColor(defaults.defaultColor)
                .darken(4)
                .toHexString(),
            buttonPrimaryShadowColor: TinyColor(defaults.primaryColor)
                .darken(4)
                .toHexString(),
            buttonDangerShadowColor: TinyColor(defaults.dangerColor)
                .darken(4)
                .toHexString(),
            buttonWarningShadowColor: TinyColor(defaults.warningColor)
                .darken(4)
                .toHexString(),
            buttonInfoShadowColor: TinyColor(defaults.infoColor)
                .darken(4)
                .toHexString(),
            buttonSuccessShadowColor: TinyColor(defaults.successColor)
                .darken(4)
                .toHexString(),
            linkTextColor: defaults.primaryColor,
            linkIconColor: defaults.primaryColor,
            inputPlaceholderColor: defaults.textSecondaryColor,
            inputLabelColor: defaults.textSecondaryColor,
            inputBorderColor: defaults.borderColor,
            inputBackgroundColor: TinyColor(defaults.backgroundColor)
                .darken(2)
                .toHexString(),
            inputTextColor: defaults.textColor,
            inputErrorPlaceholderColor: defaults.dangerColor,
            inputErrorLabelColor: defaults.dangerColor,
            inputErrorBorderColor: defaults.dangerColor,
            inputErrorBackgroundColor: TinyColor(defaults.backgroundColor)
                .darken(2)
                .toHexString(),
            inputErrorTextColor: defaults.dangerColor,
            alertMessageDefaultIconColor: defaults.textSecondaryColor,
            alertMessagePrimaryIconColor: defaults.textActiveSecondaryColor,
            alertMessageDangerIconColor: defaults.textActiveSecondaryColor,
            alertMessageWarningIconColor: defaults.textActiveSecondaryColor,
            alertMessageInfoIconColor: defaults.textActiveSecondaryColor,
            alertMessageSuccessIconColor: defaults.textActiveSecondaryColor,
            alertMessageDefaultTitleColor: defaults.textColor,
            alertMessagePrimaryTitleColor: defaults.textActiveColor,
            alertMessageDangerTitleColor: defaults.textActiveColor,
            alertMessageWarningTitleColor: defaults.textActiveColor,
            alertMessageInfoTitleColor: defaults.textActiveColor,
            alertMessageSuccessTitleColor: defaults.textActiveColor,
            alertMessageDefaultTextColor: defaults.textSecondaryColor,
            alertMessagePrimaryTextColor: defaults.textActiveSecondaryColor,
            alertMessageDangerTextColor: defaults.textActiveSecondaryColor,
            alertMessageWarningTextColor: defaults.textActiveSecondaryColor,
            alertMessageInfoTextColor: defaults.textActiveSecondaryColor,
            alertMessageSuccessTextColor: defaults.textActiveSecondaryColor,
            alertMessageDefaultBackgroundColor: defaults.defaultColor,
            alertMessagePrimaryBackgroundColor: defaults.primaryColor,
            alertMessageDangerBackgroundColor: defaults.dangerColor,
            alertMessageWarningBackgroundColor: defaults.warningColor,
            alertMessageInfoBackgroundColor: defaults.infoColor,
            alertMessageSuccessBackgroundColor: defaults.successColor,
        };
    };
    return ThemeBuilder;
}());
exports.default = ThemeBuilder;
