"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Translator_1 = require("../modules/i18n/Translator");
var AlertMessage_1 = require("../components/ui/AlertMessage");
var Container_1 = require("./ui/Container");
var Switch_1 = require("../components/ui/Switch");
var ListViewScene_1 = require("./samples/components/ListViewScene");
var FlexibleGridScene_1 = require("./samples/components/FlexibleGridScene");
var RequestScene_1 = require("./samples/modules/RequestScene");
var SessionScene_1 = require("./samples/modules/SessionScene");
var ScreenScene_1 = require("./samples/modules/ScreenScene");
var GeolocationScene_1 = require("./samples/modules/GeolocationScene");
var NetworkScene_1 = require("./samples/modules/NetworkScene");
var I18nScene_1 = require("./samples/modules/I18nScene");
var PreferenceStorageScene_1 = require("./samples/modules/PreferenceStorageScene");
var SingleStorageScene_1 = require("./samples/modules/SingleStorageScene");
var CacheStorageScene_1 = require("./samples/modules/CacheStorageScene");
var React = require("react");
var react_1 = require("@storybook/react");
var addon_actions_1 = require("@storybook/addon-actions");
var addon_info_1 = require("@storybook/addon-info");
var Button_1 = require("../components/ui/Button");
var Input_1 = require("../components/ui/Input");
var Text_1 = require("../components/ui/Text");
var Log_1 = require("../modules/logger/Log");
var View_1 = require("../components/ui/View");
var Image_1 = require("../components/ui/Image");
var Loading_1 = require("../components/ui/Loading");
var ScrollView_1 = require("../components/ui/ScrollView");
var RefreshControl_1 = require("../components/ui/RefreshControl");
var Link_1 = require("../components/ui/Link");
var MessageCenterScene_1 = require("./samples/components/MessageCenterScene");
var ModalCenterScene_1 = require("./samples/components/ModalCenterScene");
var BlurImage_1 = require("../components/ui/BlurImage");
var ViewSpacerCenterScene_1 = require("./samples/components/ViewSpacerCenterScene");
react_1.setAddon(addon_info_1.default);
var onClick = function () {
    Log_1.default.info('click');
    addon_actions_1.action('button-click');
};
react_1.storiesOf('Components', module)
    .addWithInfo('View', '', function () {
    var style = {
        backgroundColor: 'red',
        width: 200,
        height: 200
    };
    return React.createElement(View_1.default, { style: style });
})
    .addWithInfo('Image', '', function () {
    var style = {
        width: 200,
        height: 200
    };
    return (React.createElement(Image_1.default, { style: style, source: { uri: 'http://lorempixel.com/400/200/' } }));
})
    .addWithInfo('BlurImage', '', function () {
    var style = {
        width: 200,
        height: 200
    };
    return (React.createElement(View_1.default, null,
        React.createElement(BlurImage_1.default, { style: style, source: { uri: 'http://lorempixel.com/400/200/' } })));
})
    .addWithInfo('Loading', '', function () {
    return React.createElement(Loading_1.default, { size: 'small' });
})
    .addWithInfo('ScrollView', '', function () {
    var style = {
        width: 200,
        height: 200
    };
    return (React.createElement(ScrollView_1.default, { style: style }, (function () {
        var data = [];
        for (var i = 0; i < 20; i++) {
            data.push(React.createElement(Text_1.default, null, "lorem ipsum"));
        }
        return data;
    })()));
})
    .addWithInfo('RefreshControl', '', function () {
    return React.createElement(RefreshControl_1.default, { refreshing: true });
})
    .addWithInfo('Button', '', function () {
    return (React.createElement(View_1.default, null,
        React.createElement(Button_1.default, { onPress: onClick, title: 'Simple' }),
        React.createElement(Button_1.default, { onPress: onClick, title: 'Large Text' }),
        React.createElement(Button_1.default, { isLoading: true, onPress: onClick, title: 'Loading state' })));
})
    .addWithInfo('Link', '', function () {
    return React.createElement(Link_1.default, { onPress: onClick, title: 'Touchable Link' });
})
    .addWithInfo('Input', '', function () {
    return (React.createElement(View_1.default, null,
        React.createElement(Input_1.default, { placeholder: 'Username or email' }),
        React.createElement(Input_1.default, { useLabel: true, placeholder: 'Username or email' }),
        React.createElement(Input_1.default, { secureTextEntry: true, useLabel: true, placeholder: 'Username or email' })));
})
    .addWithInfo('Switch', '', function () {
    return (React.createElement(Container_1.default, null,
        React.createElement(Switch_1.default, null),
        React.createElement(Switch_1.default, { value: true })));
})
    .addWithInfo('Icon', '', function () {
    return (React.createElement(Container_1.default, null,
        React.createElement(Text_1.default, null, "TODO")));
})
    .addWithInfo('AlertMessage', '', function () {
    return (React.createElement(Container_1.default, null,
        React.createElement(AlertMessage_1.default, { message: Translator_1._('Sample message alert') })));
})
    .addWithInfo('ViewSpacer', '', function () {
    return React.createElement(ViewSpacerCenterScene_1.default, null);
})
    .addWithInfo('ListView', '', function () {
    return React.createElement(ListViewScene_1.default, null);
})
    .addWithInfo('FlexibleGrid', '', function () {
    return React.createElement(FlexibleGridScene_1.default, null);
})
    .addWithInfo('ModalCenter', '', function () {
    return React.createElement(ModalCenterScene_1.default, null);
})
    .addWithInfo('MessageCenter', '', function () {
    return React.createElement(MessageCenterScene_1.default, null);
});
react_1.storiesOf('Modules', module)
    .addWithInfo('Session', '', function () {
    return React.createElement(SessionScene_1.default, null);
})
    .addWithInfo('Translator', '', function () {
    return React.createElement(I18nScene_1.default, null);
})
    .addWithInfo('Network', '', function () {
    return React.createElement(NetworkScene_1.default, null);
})
    .addWithInfo('Geolocation', '', function () {
    return React.createElement(GeolocationScene_1.default, null);
})
    .addWithInfo('Screen', '', function () {
    return React.createElement(ScreenScene_1.default, null);
})
    .addWithInfo('Request', '', function () {
    return React.createElement(RequestScene_1.default, null);
})
    .addWithInfo('CacheStorage', '', function () {
    return React.createElement(CacheStorageScene_1.default, null);
})
    .addWithInfo('SingleStorage', '', function () {
    return React.createElement(SingleStorageScene_1.default, null);
})
    .addWithInfo('PreferencesStorage', '', function () {
    return React.createElement(PreferenceStorageScene_1.default, null);
});
