"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Translator_1 = require("../../modules/i18n/Translator");
var Button_1 = require("../../components/ui/Button");
var React = require("react");
var Title_1 = require("../ui/Title");
var Container_1 = require("../ui/Container");
var Value_1 = require("../ui/Value");
var Emitter_1 = require("../../modules/listener/Emitter");
var Network_1 = require("../../modules/listener/Network");
var NetworkScene = (function (_super) {
    __extends(NetworkScene, _super);
    function NetworkScene() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            type: ''
        };
        return _this;
    }
    NetworkScene.prototype.componentDidMount = function () {
        Network_1.default.init();
        this.onNetworkStateChangeListener = Emitter_1.default.on('onNetworkStateChange', this.onNetworkStateChange.bind(this));
        this.getData();
    };
    NetworkScene.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onNetworkStateChangeListener);
        Network_1.default.destroy();
    };
    NetworkScene.prototype.onNetworkStateChange = function (type) {
        this.setState({ type: type });
    };
    NetworkScene.prototype.getData = function () {
        Network_1.default.updateNetworkType();
    };
    NetworkScene.prototype.render = function () {
        var type = this.state.type;
        return (React.createElement(Container_1.default, null,
            React.createElement(Title_1.default, null, Translator_1._('Network')),
            React.createElement(Value_1.default, null, Translator_1._('Type: {type}', { type: type })),
            React.createElement(Button_1.default, { onPress: this.getData.bind(this), title: Translator_1._('Get Data') })));
    };
    return NetworkScene;
}(React.Component));
exports.default = NetworkScene;
