"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Translator_1 = require("../../modules/i18n/Translator");
var Button_1 = require("../../components/ui/Button");
var React = require("react");
var Title_1 = require("../ui/Title");
var Container_1 = require("../ui/Container");
var Value_1 = require("../ui/Value");
var Emitter_1 = require("../../modules/listener/Emitter");
var Screen_1 = require("../../modules/listener/Screen");
var ScreenScene = (function (_super) {
    __extends(ScreenScene, _super);
    function ScreenScene() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            size: '',
            orientation: ''
        };
        return _this;
    }
    ScreenScene.prototype.componentDidMount = function () {
        Screen_1.default.init();
        this.onDimensionsChangeListener = Emitter_1.default.on('onDimensionsChange', this.onDimensionsChange.bind(this));
        this.onOrientationChangeListener = Emitter_1.default.on('onOrientationChange', this.onOrientationChange.bind(this));
        this.getData();
    };
    ScreenScene.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onDimensionsChangeListener);
        Emitter_1.default.off(this.onDimensionsChangeListener);
        Screen_1.default.destroy();
    };
    ScreenScene.prototype.onDimensionsChange = function (size) {
        var jsonData = {
            width: size.width,
            height: size.height
        };
        this.setState({ size: JSON.stringify(jsonData) });
    };
    ScreenScene.prototype.onOrientationChange = function (orientation) {
        this.setState({ orientation: orientation });
    };
    ScreenScene.prototype.getData = function () {
        Screen_1.default.updateOrientation();
        Screen_1.default.updateDimensions();
    };
    ScreenScene.prototype.render = function () {
        var _a = this.state, size = _a.size, orientation = _a.orientation;
        return (React.createElement(Container_1.default, null,
            React.createElement(Title_1.default, null, Translator_1._('Screen')),
            React.createElement(Value_1.default, null, Translator_1._('Size: {size}', { size: size })),
            React.createElement(Value_1.default, null, Translator_1._('Orientation: {orientation}', { orientation: orientation })),
            React.createElement(Button_1.default, { onPress: this.getData.bind(this), title: Translator_1._('Get Data') })));
    };
    return ScreenScene;
}(React.Component));
exports.default = ScreenScene;
