"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Button_1 = require("../../../components/ui/Button");
var Translator_1 = require("../../../modules/i18n/Translator");
var Emitter_1 = require("../../../modules/listener/Emitter");
var React = require("react");
var Title_1 = require("../../ui/Title");
var Container_1 = require("../../ui/Container");
var Value_1 = require("../../ui/Value");
var Geolocation_1 = require("../../../modules/listener/Geolocation");
var GeolocationScene = (function (_super) {
    __extends(GeolocationScene, _super);
    function GeolocationScene() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            coordinates: ''
        };
        return _this;
    }
    GeolocationScene.prototype.componentDidMount = function () {
        Geolocation_1.default.init();
        this.onLocationChangeListener = Emitter_1.default.on('onLocationChange', this.onLocationChange.bind(this));
        this.getData();
    };
    GeolocationScene.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onLocationChangeListener);
        Geolocation_1.default.destroy();
    };
    GeolocationScene.prototype.onLocationChange = function (coordinates) {
        var jsonData = {
            latitude: coordinates.latitude,
            longitude: coordinates.longitude
        };
        this.setState({ coordinates: JSON.stringify(jsonData) });
    };
    GeolocationScene.prototype.getData = function () {
        Geolocation_1.default.updateLocation();
    };
    GeolocationScene.prototype.render = function () {
        var coordinates = this.state.coordinates;
        return (React.createElement(Container_1.default, null,
            React.createElement(Title_1.default, null, Translator_1._('Location')),
            React.createElement(Value_1.default, null, Translator_1._('Location: {coordinates}', { coordinates: coordinates })),
            React.createElement(Button_1.default, { onPress: this.getData.bind(this), title: Translator_1._('Get Data') })));
    };
    return GeolocationScene;
}(React.Component));
exports.default = GeolocationScene;
