"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Translator_1 = require("../../../modules/i18n/Translator");
var React = require("react");
var Title_1 = require("../../ui/Title");
var Container_1 = require("../../ui/Container");
var Input_1 = require("../../../components/ui/Input");
var Emitter_1 = require("../../../modules/listener/Emitter");
var Log_1 = require("../../../modules/logger/Log");
var Auth_1 = require("../../../modules/session/Auth");
var Value_1 = require("../../ui/Value");
var Button_1 = require("../../../components/ui/Button");
var SessionScene = (function (_super) {
    __extends(SessionScene, _super);
    function SessionScene() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isLoading: false,
            isLogged: false,
            value: ''
        };
        return _this;
    }
    SessionScene.prototype.componentDidMount = function () {
        Auth_1.default.init({
            headerName: 'X-ApiKey',
            authPath: 'user/me'
        });
        this.onSuccessLoginListener = Emitter_1.default.on('onSuccessLogin', this.onSuccessLogin.bind(this));
    };
    SessionScene.prototype.componentWillUnmount = function () {
        Emitter_1.default.off(this.onSuccessLoginListener);
    };
    SessionScene.prototype.onSuccessLogin = function (data) {
        if (this.state.isLoading) {
            return;
        }
        this.goToMain();
    };
    SessionScene.prototype.goToMain = function () {
        var _this = this;
        setTimeout(function () {
            _this.setState({ isLogged: true });
        }, 100);
    };
    SessionScene.prototype.onLogin = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var username, password, isValidUser, response, body, success;
            return __generator(this, function (_a) {
                username = this.refs.username.getValue();
                password = this.refs.password.getValue();
                this.setState({ isLoading: true, isLogged: false });
                try {
                    isValidUser = 'demo@demo.com' === username && '123456' === password;
                    response = {
                        status: isValidUser ? 200 : 404,
                        body: {
                            id: 1,
                            apiKey: 'abc'
                        },
                        headers: {}
                    };
                    if (response.status === 200) {
                        body = response.body;
                        success = true;
                        if (success) {
                            this.goToMain();
                        }
                        else {
                            Log_1.default.warn('login', 'auth error');
                        }
                    }
                    else {
                        Log_1.default.warn('login', 'status error');
                    }
                }
                catch (e) {
                    Log_1.default.warn('login', e);
                }
                setTimeout(function () {
                    _this.setState({ isLoading: false });
                }, 100);
                return [2 /*return*/];
            });
        });
    };
    SessionScene.prototype.render = function () {
        var _a = this.state, isLogged = _a.isLogged, isLoading = _a.isLoading;
        var ok = isLogged ? 'YEP' : 'NOP';
        return (React.createElement(Container_1.default, null,
            React.createElement(Title_1.default, null, Translator_1._('Auth')),
            React.createElement(Input_1.default, { useLabel: true, defaultValue: 'demo@demo.com', placeholder: Translator_1._('Username'), ref: 'username' }),
            React.createElement(Input_1.default, { useLabel: true, defaultValue: '123456', placeholder: Translator_1._('Password'), ref: 'password' }),
            React.createElement(Button_1.default, { onPress: this.onLogin.bind(this), title: Translator_1._('Login') }),
            !isLoading && React.createElement(Value_1.default, null, Translator_1._('Is logged: {ok}', { ok: ok }))));
    };
    return SessionScene;
}(React.Component));
exports.default = SessionScene;
